

DSEG SEGMENT 'DATA'
; some messages
msg DB "Can't run standalone.",0DH,0AH,'$'
msg1 DB "Hello from testdll.asm.",0DH,0AH,'$'
msg2 DB "testdll.asm says hello to ",'$'
msg2end DB ".",0DH,0AH,'$'

;names of exported functions
fname0 DB 'sayHello',0
fname1 DB 'sayHello(const char*)',0

;export table
;first entry
funcEntry0 DW OFFSET fname0
           DW SEG DSEG
           DW func0
           DW SEG CSEG
;second entry           
funcEntry1 DW OFFSET fname1
           DW SEG DSEG
           DW func1
           DW SEG CSEG
           
;DllRegStruct - the registration structure
regTag DB 'D_O_S_L_I_B0'    ; tag searched from main program
oEntryFunc DW OFFSET entryFunc  ; offset of entry point function
sEntryFunc DW SEG CSEG          ; segment of entry point function  
oEntryArray DW funcEntry0       ; address of export table
sEntryArray DW SEG DSEG
entryCnt    DW 2                ; number of entries in export table
DSEG ENDS

CSEG SEGMENT 'CODE'
; dummy entry function if started from command line
DUMMY PROC FAR 
     MOV AX, DSEG
     MOV DS, AX
     XOR AX, AX 
     LEA DX, msg
     CALL PUTS
     MOV AX, 4c00h
     INT 21h
     RET
DUMMY ENDP

; Displays the message (DX-address)
PUTS    PROC    NEAR
        PUSH    AX
        MOV     AH, 09h
        INT     21h
        POP     AX
        RET
PUTS    ENDP

; Entry point function
; It does nothing because all initialization was made static
entryFunc PROC FAR
       RET
entryFunc ENDP

; implementation of first exported function sayHello
func0 PROC FAR
     PUSH DS
     MOV AX, DSEG
     MOV DS, AX
     LEA DX, msg1
     CALL PUTS
     POP DS
     RET 
func0 ENDP

; implementation of second exported function sayHello(const char*)
func1 PROC FAR
     PUSH DS
     MOV AX, DSEG
     MOV DS, AX
     LEA DX, msg2
     CALL PUTS
     ; get address of C-string from stack
     MOV SI, SP
     MOV AX, SS:[SI+8] ; Segment of string parameter
     MOV ES, AX
     MOV DI, SS:[SI+6] ; Offset of string parameter
     MOV AH, 2 ; DOS Display output
  printchar:
     MOV DL, ES:[DI]
     CMP DL, 0
     JE endprint ; C-string ends with a zero byte.
     INT 21H
     INC DI, 1
     JMP printchar
  endprint:
     LEA DX, msg2end
     CALL PUTS
     POP DS
     RET 
func1 ENDP

     
CSEG ENDS
     END DUMMY

